Index: GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp	(revision 1287)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp	(revision 1315)
@@ -14,5 +14,5 @@
 #include "RssTree.h"
 #include "Beam.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 1292)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 1315)
@@ -363,8 +363,8 @@
 			</File>
 			<File
-				RelativePath="..\src\KdIntersectable.cpp">
-			</File>
-			<File
-				RelativePath="..\src\KdIntersectable.h">
+				RelativePath=".\IntersectableWrapper.cpp">
+			</File>
+			<File
+				RelativePath=".\IntersectableWrapper.h">
 			</File>
 			<File
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1313)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1315)
@@ -18,5 +18,5 @@
 #include "GlRenderer.h"
 #include "ResourceManager.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 #include "VspTree.h"
 #include "OspTree.h"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Exporter.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Exporter.cpp	(revision 1293)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Exporter.cpp	(revision 1315)
@@ -3,5 +3,5 @@
 #include "OspTree.h"
 #include "KdTree.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 #include "BvHierarchy.h"
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h	(revision 1305)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h	(revision 1315)
@@ -12,5 +12,5 @@
 #include "SubdivisionCandidate.h"
 #include "AxisAlignedBox3.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.cpp	(revision 1315)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.cpp	(revision 1315)
@@ -0,0 +1,9 @@
+#include "IntersectableWrapper.h"
+
+
+namespace GtpVisibilityPreprocessor {
+
+
+
+	
+}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 1314)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 1315)
@@ -17,5 +17,5 @@
 #include "Beam.h"
 #include "KdTree.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 #include "HierarchyManager.h"
 #include "BvHierarchy.h"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 1314)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 1315)
@@ -13,5 +13,5 @@
 #include "Environment.h"
 #include "ResourceManager.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.cpp	(revision 1293)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.cpp	(revision 1315)
@@ -3,5 +3,5 @@
 #include "Pvs.h"
 #include "Intersectable.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 #include "KdTree.h"
 #include "common.h"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 1314)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 1315)
@@ -17,5 +17,5 @@
 #include "Beam.h"
 #include "KdTree.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 #include "VspTree.h"
 #include "OspTree.h"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/OspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/OspTree.cpp	(revision 1297)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/OspTree.cpp	(revision 1315)
@@ -17,5 +17,5 @@
 #include "Beam.h"
 #include "KdTree.h"
-#include "KdIntersectable.h"
+#include "IntersectableWrapper.h"
 #include "VspTree.h"
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.h	(revision 1315)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.h	(revision 1315)
@@ -0,0 +1,181 @@
+#ifndef __KDINTERSECTABLE_H
+#define __KDINTERSECTABLE_H
+
+#include "AxisAlignedBox3.h"
+#include "Intersectable.h"
+
+
+namespace GtpVisibilityPreprocessor {
+
+struct VssRayContainer;
+class KdNode;
+class BvhNode;
+struct Face;
+
+
+/**
+	Wrapper used for creating a PVS compliant intersectable.
+*/
+template<typename T>
+class IntersectableWrapper: public Intersectable
+{
+public:
+	IntersectableWrapper(T *item);
+
+	/** Returns node associated with this instance. 
+	*/
+	T *GetItem() const;
+
+	/** See get.
+	*/
+	void SetItem(T *item);
+
+	//-- inherited functions from Intersectable
+
+	AxisAlignedBox3 GetBox() const;
+	
+	int CastRay(Ray &ray);
+	
+	bool IsConvex() const;
+	bool IsWatertight() const;
+	float IntersectionComplexity();
+  
+	int NumberOfFaces() const;
+	//int Type() const;
+
+	int GetRandomSurfacePoint(GtpVisibilityPreprocessor::Vector3 &point, 
+							  GtpVisibilityPreprocessor::Vector3 &normal);
+
+	int GetRandomVisibleSurfacePoint(GtpVisibilityPreprocessor::Vector3 &point,
+									 GtpVisibilityPreprocessor::Vector3 &normal,
+									 const GtpVisibilityPreprocessor::Vector3 &viewpoint,
+									 const int maxTries);
+  
+	ostream &Describe(ostream &s);
+	
+
+protected:
+	
+	T *mItem;
+};
+
+
+template<typename T>
+IntersectableWrapper<T>::IntersectableWrapper(T *item):
+Intersectable(), mItem(item)
+{
+}
+
+template<typename T>
+void IntersectableWrapper<T>::SetItem(T *item)
+{
+	mItem = item;
+}
+
+template<typename T>
+T *IntersectableWrapper<T>::GetItem() const
+{ 
+	return mItem; 
+}
+	
+template<typename T>
+AxisAlignedBox3 IntersectableWrapper<T>::GetBox() const
+{	// TODO matt
+	return AxisAlignedBox3();
+}
+
+template<typename T>
+int IntersectableWrapper<T>::CastRay(Ray &ray)
+{	// TODO matt
+	return 0;
+}
+	
+template<typename T>
+bool IntersectableWrapper<T>::IsConvex() const
+{
+	return true;
+}
+
+template<typename T>
+bool IntersectableWrapper<T>::IsWatertight() const
+{
+	return true;
+}
+
+template<typename T>
+float IntersectableWrapper<T>::IntersectionComplexity()
+{
+	return 1.0f;
+}
+
+template<typename T>
+int IntersectableWrapper<T>::NumberOfFaces() const
+{
+	return 0;
+}
+
+template<typename T>
+int IntersectableWrapper<T>::GetRandomSurfacePoint(Vector3 &point,
+												Vector3 &normal)
+{
+	return 0;
+}
+
+template<typename T>
+int IntersectableWrapper<T>::GetRandomVisibleSurfacePoint(Vector3 &point,
+													   Vector3 &normal,
+													   const Vector3 &viewpoint,
+													   const int maxTries)
+{
+	return 0;
+}
+  
+template<typename T>
+ostream &IntersectableWrapper<T>::Describe(ostream &s)
+{
+	s << mItem;
+	return s;
+}
+
+
+class KdIntersectable: public IntersectableWrapper<KdNode>
+{
+public:
+	KdIntersectable(KdNode *item):
+	IntersectableWrapper<KdNode>(item) {}
+
+	int Type() const
+	{
+		return Intersectable::KD_INTERSECTABLE;
+	}
+};
+
+
+class BvhIntersectable: public IntersectableWrapper<BvhNode>
+{
+public:
+	BvhIntersectable(BvhNode *item):
+	IntersectableWrapper<BvhNode>(item) {}
+
+	int Type() const
+	{
+		return Intersectable::BVH_INTERSECTABLE;
+	}
+};
+
+class FaceIntersectable: public IntersectableWrapper<Face>
+{
+public:
+	FaceIntersectable(Face *item):
+	IntersectableWrapper<Face>(item) {}
+
+	int Type() const
+	{
+		return Intersectable::FACE_INTERSECTABLE;
+	}
+};
+
+
+}
+
+#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/KdIntersectable.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/KdIntersectable.h	(revision 1314)
+++ 	(revision )
@@ -1,181 +1,0 @@
-#ifndef __KDINTERSECTABLE_H
-#define __KDINTERSECTABLE_H
-
-#include "AxisAlignedBox3.h"
-#include "Intersectable.h"
-
-
-namespace GtpVisibilityPreprocessor {
-
-struct VssRayContainer;
-class KdNode;
-class BvhNode;
-struct Face;
-
-
-/**
-	Wrapper used for creating a PVS compliant intersectable.
-*/
-template<typename T>
-class IntersectableWrapper: public Intersectable
-{
-public:
-	IntersectableWrapper(T *item);
-
-	/** Returns node associated with this instance. 
-	*/
-	T *GetItem() const;
-
-	/** See get.
-	*/
-	void SetItem(T *item);
-
-	//-- inherited functions from Intersectable
-
-	AxisAlignedBox3 GetBox() const;
-	
-	int CastRay(Ray &ray);
-	
-	bool IsConvex() const;
-	bool IsWatertight() const;
-	float IntersectionComplexity();
-  
-	int NumberOfFaces() const;
-	//int Type() const;
-
-	int GetRandomSurfacePoint(GtpVisibilityPreprocessor::Vector3 &point, 
-							  GtpVisibilityPreprocessor::Vector3 &normal);
-
-	int GetRandomVisibleSurfacePoint(GtpVisibilityPreprocessor::Vector3 &point,
-									 GtpVisibilityPreprocessor::Vector3 &normal,
-									 const GtpVisibilityPreprocessor::Vector3 &viewpoint,
-									 const int maxTries);
-  
-	ostream &Describe(ostream &s);
-	
-
-protected:
-	
-	T *mItem;
-};
-
-
-template<typename T>
-IntersectableWrapper<T>::IntersectableWrapper(T *item):
-Intersectable(), mItem(item)
-{
-}
-
-template<typename T>
-void IntersectableWrapper<T>::SetItem(T *item)
-{
-	mItem = item;
-}
-
-template<typename T>
-T *IntersectableWrapper<T>::GetItem() const
-{ 
-	return mItem; 
-}
-	
-template<typename T>
-AxisAlignedBox3 IntersectableWrapper<T>::GetBox() const
-{	// TODO matt
-	return AxisAlignedBox3();
-}
-
-template<typename T>
-int IntersectableWrapper<T>::CastRay(Ray &ray)
-{	// TODO matt
-	return 0;
-}
-	
-template<typename T>
-bool IntersectableWrapper<T>::IsConvex() const
-{
-	return true;
-}
-
-template<typename T>
-bool IntersectableWrapper<T>::IsWatertight() const
-{
-	return true;
-}
-
-template<typename T>
-float IntersectableWrapper<T>::IntersectionComplexity()
-{
-	return 1.0f;
-}
-
-template<typename T>
-int IntersectableWrapper<T>::NumberOfFaces() const
-{
-	return 0;
-}
-
-template<typename T>
-int IntersectableWrapper<T>::GetRandomSurfacePoint(Vector3 &point,
-												Vector3 &normal)
-{
-	return 0;
-}
-
-template<typename T>
-int IntersectableWrapper<T>::GetRandomVisibleSurfacePoint(Vector3 &point,
-													   Vector3 &normal,
-													   const Vector3 &viewpoint,
-													   const int maxTries)
-{
-	return 0;
-}
-  
-template<typename T>
-ostream &IntersectableWrapper<T>::Describe(ostream &s)
-{
-	s << mItem;
-	return s;
-}
-
-
-class KdIntersectable: public IntersectableWrapper<KdNode>
-{
-public:
-	KdIntersectable(KdNode *item):
-	IntersectableWrapper<KdNode>(item) {}
-
-	int Type() const
-	{
-		return Intersectable::KD_INTERSECTABLE;
-	}
-};
-
-
-class BvhIntersectable: public IntersectableWrapper<BvhNode>
-{
-public:
-	BvhIntersectable(BvhNode *item):
-	IntersectableWrapper<BvhNode>(item) {}
-
-	int Type() const
-	{
-		return Intersectable::BVH_INTERSECTABLE;
-	}
-};
-
-class FaceIntersectable: public IntersectableWrapper<Face>
-{
-public:
-	FaceIntersectable(Face *item):
-	IntersectableWrapper<Face>(item) {}
-
-	int Type() const
-	{
-		return Intersectable::FACE_INTERSECTABLE;
-	}
-};
-
-
-}
-
-#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/KdIntersectable.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/KdIntersectable.cpp	(revision 1233)
+++ 	(revision )
@@ -1,9 +1,0 @@
-#include "KdIntersectable.h"
-
-
-namespace GtpVisibilityPreprocessor {
-
-
-
-	
-}